@echo off

:config
set benutzer=Administrator
set kennwort=geheim
set an_aktion=%~dp0%~nx0
set aus_aktion=C:\Programme\DBxRecStartAndShutdown\DBxRecStShutdown.exe

:auswertung
if "%1"=="log" goto log-schreiben
if "%1"=="" goto fehler
if "%2"=="" goto fehler
if "%3"=="" goto fehler
if "%4"=="" goto fehler
set an_tag=%1
set an_zeit=%2:00
set aus_tag=%3
set aus_zeit=%4:00
set an_aufgabename=%an_tag:~6,4%-%an_tag:~3,2%-%an_tag:~0,2% um %an_zeit:~0,2%.%an_zeit:~3,2% Aufnahme
set aus_aufgabename=%aus_tag:~6,4%-%aus_tag:~3,2%-%aus_tag:~0,2% um %aus_zeit:~0,2%.%aus_zeit:~3,2% Ausschalten

:planung_fuer_anschalten
schtasks /create /tn "%an_aufgabename%" /xml an_template.xml  /ru "%benutzer%" /rp "%kennwort%" /it
if "%an_aktion%"=="%~dp0%~nx0" schtasks /change /tn "%an_aufgabename%" /tr "'%an_aktion%' log" /sd %an_tag:~0,2%/%an_tag:~3,2%/%an_tag:~6,4% /st %an_zeit% /rp "%kennwort%" /it
if not "%an_aktion%"=="%~dp0%~nx0" schtasks /change /tn "%an_aufgabename%" /tr "'%an_aktion%'" /sd %an_tag:~0,2%/%an_tag:~3,2%/%an_tag:~6,4% /st %an_zeit% /rp "%kennwort%" /it

:planung_fuer_ausschalten
schtasks /create /tn "%aus_aufgabename%" /xml aus_template.xml  /ru "%benutzer%" /rp "%kennwort%" /it
schtasks /change /tn "%aus_aufgabename%" /tr "'%aus_aktion%'" /sd %aus_tag:~0,2%/%aus_tag:~3,2%/%aus_tag:~6,4% /st %aus_zeit% /rp "%kennwort%" /it
goto ende

:log-schreiben
date /t >> "%~dp0log.txt"
time /t >> "%~dp0log.txt"
echo.   >> "%~dp0log.txt"
goto ende

:fehler
echo.
echo Es muss folgende Syntax verwendet werden:
echo.
echo planer.cmd an_tag an_zeit aus_tag aus_zeit
echo mit diesem Format: dd.mm.jjjj hh:mm dd.mm.jjjj hh:mm
echo.
echo Bsp.: planer.cmd 03.01.2010 23:55 04.01.2010 01:15
echo.
pause > nul
goto ende

:ende
exit